package primi;
public class CrivelloPrimeSet2 extends AbstractPrimi{
    PrimeSet2 primi;

    public CrivelloPrimeSet2(long n){
    	super(n);
    	this.primi = new PrimeSet2(n);
    }
    
    public int go(){
		primi.set(2, n);
		long i = 2;
		while (i * i < n) {
			i = primi.nextSetBit(i + 1);
			for (long k = i * i; k < n; k += i)
				primi.clear(k);
		}
		return primi.cardinality();
	}
}