package primi;

import java.util.BitSet;

public final class PrimeSet {
	private BitSet primeset;

	public PrimeSet(long n) {
		this.primeset = new BitSet((int) n);
	}

	public void set(long fromIndex, long toIndex) {
		primeset.set((int) fromIndex, (int) toIndex);
	}

	public long nextSetBit(long fromIndex) {
		long i = fromIndex;
		while (!this.get(i++)) {}
		return i - 1;
	}

	public int cardinality() {
		return primeset.cardinality();
	}

	public void set(long i) {
		primeset.set((int) i);
	}

	public void clear(long i) {
		primeset.clear((int) i);
	}

	public boolean get(long i) {
		return primeset.get((int) i);
	}
}