package sort;
public class MergeSort extends AbstractSort {
	int[] v = new int[n];
	
	public void go() {	
		mergeSort(0, n - 1);
	}

	private void mergeSort(int left, int right) {
		if (left < right) {
			int center = (left + right) / 2;
			mergeSort(left, center);
			mergeSort(center + 1, right);
			merge(left, center + 1, right);
		}
	}

	private void merge(int posLeft, int posRight, int posEnd) {
		int endLeft = posRight - 1;
		int posAux = posLeft;
		int numElemen = posEnd - posLeft + 1;

		while (posLeft <= endLeft && posRight <= posEnd)
			if ((A[posLeft]) < (A[posRight])) v[posAux++] = A[posLeft++];
			else v[posAux++] = A[posRight++];

		while (posLeft <= endLeft)
			v[posAux++] = A[posLeft++];

		while (posRight <= posEnd)
			v[posAux++] = A[posRight++];

		for (int i = 0; i < numElemen; i++, posEnd--)
			A[posEnd] = v[posEnd];
	}

}
