package sort;
public abstract class AbstractSort {

	static int n = 0;

	static String type = "?";

	static int[] B = null;

	int[] A;

	public void pre(int n1, String type1) {
		if (n1 != n || !type1.equals(type)) {
			System.out.println("\n building array, size " + n1 + " type " + type1);
			n = n1;
			type = type1;
			B = new int[n];
			if (type.equals("DIRETTO")) createD();
			else if (type.equals("RANDOM")) createR();
			else if (type.equals("INVERSO")) createI();
			else if (type.equals("UNI")) createU();
			else if (type.equals("ALTERNATO")) createX();
			else throw new IllegalArgumentException(" Unknown TYPE " + type);
		}
		A = B.clone();
	}

	private void createU() {
		for (int i = 0; i < n; i++)
			B[i] = 1;
	}

	private void createD() {
		for (int i = 0; i < n; i++)
			B[i] = i;
	}

	private void createI() {
		for (int i = 0; i < n; i++)
			B[i] = -i;
	}

	private void createR() {
		int m = Math.max(1000, n - 1000);
		for (int i = 0; i < n; i++)
			B[i] = (int) (m * Math.random());
	}

	private void createX() {
		for (int i = 0; i < n/2; i++)
			B[i] = i;
		for (int i = n/2+1; i < n; i++)
			B[i] = i-n/2;
	}

	public abstract void go();

	public boolean verify() {
		for (int i = 1; i < n; i++)
			if (A[i - 1] > A[i]) return false;
		return true;
	}

	void swap(int i, int j) {
		int h = A[i];
		A[i] = A[j];
		A[j] = h;
	}
	
	void dump() {
		for (int i = 0; i < n; i++)
			System.out.print(A[i]+" ");
		System.out.println(" ");
	}

}